SystemOrganization addCategory: #'Newspeak-gui-menubar'!
SystemOrganization addCategory: #Newspeak!

!PluggableTextMorph methodsFor: '*Newspeak-gui' stamp: 'Ahe 7/31/2007 22:49'!
removeAllFormatting

self text runs: self text asString asText runs
! !

!Morph methodsFor: '*Newspeak-docking bar' stamp: 'eem 10/5/2007 13:29'!
isNewsqueakDockingBarMorph
	^false! !

!ChangeSet methodsFor: '*Newspeak' stamp: 'Ahe 10/3/2007 16:53'!
copyExternalSendersToCurrentChangeSet
	^self externalSenders do: [ :each | ChangeSet current adoptSelector:  each value forClass: each key ]! !

!ChangeSet methodsFor: '*Newspeak' stamp: 'Ahe 10/3/2007 17:09'!
externalSenders
	| allChanges allCalls |
	allChanges := (Array streamContents: [ :a | changeRecords keysAndValuesDo: [ :sym :changes | changes methodChanges keysDo: [ :selector | a nextPut: (Smalltalk classNamed: sym) -> selector ]]]) asSet.
	allCalls := (Array streamContents: [ :b | allChanges do: [ :each | b nextPutAll: 	((SystemNavigation default allCallsOn: each value) collect: [:ref | (Smalltalk at: ref classSymbol ifPresent: [:cls | ref classIsMeta ifTrue: [cls classSide ] ifFalse: [ cls] ]) -> ref methodSymbol])]]) asSet.
	^allCalls copyWithoutAll: allChanges! !

UpdatingMenuMorph subclass: #DynamicMenuMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Newspeak-gui-menubar'!

!DynamicMenuMorph commentStamp: '<historical>' prior: 0!
Copyright 2008 Cadence Design Systems, Inc.
   
   Licensed under the Apache License, Version 2.0 (the ''License''); you may not use this file except in compliance with the License.  You may obtain a copy of the License at  http://www.apache.org/licenses/LICENSE-2.0
!

!DynamicMenuMorph methodsFor: 'events' stamp: 'ryan 6/22/2011 11:32'!
activatedFromDockingBar: dontCare! !

!DynamicMenuMorph methodsFor: 'events' stamp: 'ryan 6/13/2011 12:42'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem 

	self updateMenu.
	^super popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem! !

!DynamicMenuMorph methodsFor: 'keyboard control' stamp: 'Ahe 10/26/2007 13:43'!
removeMatchString! !

!PositionableStream methodsFor: '*newspeak' stamp: 'GB 1/8/2010 11:12'!
peekIfAbsent: blk
	^self peek! !

!Debugger methodsFor: '*Newspeak' stamp: 'Ahe 8/1/2007 22:15'!
openErrorReport
	| errorReport |

	Cursor wait showWhile:
		[ errorReport :=
			String
				streamContents: [:s| self interruptedContext errorReportOn: s] ].
	Workspace new
		contents: errorReport;
		openLabel: 'Error Report'.
! !

DockingBarMorph subclass: #NewsqueakDockingBar
	instanceVariableNames: 'imageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Newspeak-gui-menubar'!

!NewsqueakDockingBar commentStamp: '<historical>' prior: 0!
Usage:

NewsqueakDockingBar setup.
NewsqueakDockingBar stickyTranscript.


   Copyright 2008 Cadence Design Systems, Inc.
   
   Licensed under the Apache License, Version 2.0 (the ''License''); you may not use this file except in compliance with the License.  You may obtain a copy of the License at  http://www.apache.org/licenses/LICENSE-2.0
!

!NewsqueakDockingBar class methodsFor: 'class initialization' stamp: 'Ahe 6/13/2008 18:11'!
initialize

	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self! !

!NewsqueakDockingBar class methodsFor: 'accessing' stamp: 'ryan 6/13/2011 12:34'!
setup
	| instance |

	World deleteDockingBars. 
	instance:= self new openInWorld.
	World restoreMorphicDisplay.
	^instance! !

!NewsqueakDockingBar class methodsFor: 'as yet unclassified' stamp: 'ryan 6/13/2011 12:34'!
shutDown

	self allInstances do: [ :each | each shutDown]! !

!NewsqueakDockingBar class methodsFor: 'system startup' stamp: 'ryan 6/13/2011 12:34'!
startUp

	self allInstances do: [ :each | each startUp ]! !

!NewsqueakDockingBar class methodsFor: 'accessing' stamp: 'ryan 6/13/2011 12:34'!
stickyBigTranscript

	| menu transMorph frame rect |

	menu:= DockingBarMorph new.
	transMorph:= PluggableTextMorph on: Transcript text: nil accept: nil readSelection: nil menu: #codePaneMenu:shifted:.
	frame:= LayoutFrame new.
	frame 
		leftFraction: 0; 
		rightFraction: 1; 
		topFraction: 0; 
		bottomFraction: 1.
	rect:= RectangleMorph new.
	rect
		height: 120;
		width: 1.
	menu
		addMorph: transMorph fullFrame: frame;
		addMorphBack: rect;
		adhereToBottom;
		openInWorld.! !

!NewsqueakDockingBar class methodsFor: 'accessing' stamp: 'ryan 6/13/2011 12:34'!
stickyTranscript

	| menu transMorph frame rect |

	menu:= DockingBarMorph new.
	transMorph:= PluggableTextMorph on: Transcript text: nil accept: nil readSelection: nil menu: #codePaneMenu:shifted:.
	frame:= LayoutFrame new.
	frame 
		leftFraction: 0; 
		rightFraction: 1; 
		topFraction: 0; 
		bottomFraction: 1.
	rect:= RectangleMorph new.
	rect
		height: 60;
		width: 1.
	menu
		addMorph: transMorph fullFrame: frame;
		addMorphBack: rect;
		adhereToBottom;
		openInWorld.! !

!NewsqueakDockingBar methodsFor: 'construction' stamp: 'ryan 6/13/2011 12:37'!
add: name dynamicSubMenu: selector
	| dynamicMenu |
	dynamicMenu:= DynamicMenuMorph new
		updater: self updateSelector: selector;
		updateMenu.
	self add: name subMenu: dynamicMenu! !

!NewsqueakDockingBar methodsFor: 'initialize-release' stamp: 'ryan 6/13/2011 12:36'!
addMenus

	self addSpace: 10.
	self add: 'File' dynamicSubMenu: #updateFile:.

	self addSpace: 10.
	self add: 'View' dynamicSubMenu: #updateView:.

	self addSpace: 10.
	self add: 'Tools' dynamicSubMenu:  #updateTools:.

	self addSpace: 10.
	self add: 'Applications' dynamicSubMenu:  #updateApplications:.

	"addSpace: 10.
	add: 'Monticello' dynamicSubMenu: #updateMonticello:."

	self addSpace: 10.
	self add: 'Changes' dynamicSubMenu: #updateChanges:.

	self addSpace: 10.
	self add: 'Windows' dynamicSubMenu: #updateWindows:! !

!NewsqueakDockingBar methodsFor: 'initialize-release' stamp: 'ryan 6/13/2011 12:36'!
addMiddleLabel

	self addSpacer.
	imageName:= StringMorph contents: self baseMiddleLabel.
	self addMorphBack: imageName! !

!NewsqueakDockingBar methodsFor: 'as yet unclassified' stamp: 'ryan 6/13/2011 12:35'!
baseMiddleLabel
	"Answer a label composed of the image name and the VM name (with duplication removed)"
	| sic imageBaseName  |
	sic:= SmalltalkImage current.
	imageBaseName:= FileDirectory baseNameFor: (FileDirectory localNameFor: sic imageName).
	Smalltalk at: #SystemInformationPresenter ifAbsent: [ | vmVersionTokens |
		vmVersionTokens:= (sic getSystemAttribute: 1004) findTokens: ' '.
		^imageBaseName, '    ',
			((vmVersionTokens asSet asSortedCollection:
				[:t1 :t2| (vmVersionTokens indexOf: t1) <= (vmVersionTokens indexOf: t2)]) fold:
					[:t1 :t2| t1, ' ', t2])].
	^imageBaseName! !

!NewsqueakDockingBar methodsFor: 'menu-action-changes' stamp: 'Ahe 8/29/2007 00:50'!
browseChangeLog

	ChangeList browseRecentLog! !

!NewsqueakDockingBar methodsFor: 'menu-action-changes' stamp: 'Ahe 8/29/2007 00:51'!
checkForSlips

	ChangeSet current lookForSlips! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 2/22/2012 12:08'!
compileLanguageFile
	| fileRequester |
	fileRequester:= (Request usingPlatform: BlackMarket platform) File new.
	fileRequester allowedFileTypes: {
		'Newspeak source file (*.ns*)' ->'*.ns*'.
		'Smalltalk source file (*.st)' -> '*.rtf'.
		'Any files (*.*)' -> '*.*'}.
	fileRequester initialDirectory: (FileDirectory default fullName).
	fileRequester openModal ifNotNil: [:fn |
		| cls |
		cls:= Cursor wait showWhile: [LanguageFileReader new compileFile: fn].
		BlackMarket ide IDEWindow openOnClass: cls].! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:38'!
documentation
	| launcher loc |

	loc:= self documentationLocation.
	loc isNil ifTrue: [^self].

	OSProcess isWindows ifTrue: [
		NsToolSet
			windowsShellExecuteOperation: 'open'
			file: loc
			parameters: 0
			directory: 0.
		^self].
		
	launcher:= self getLauncher.	
	launcher isNil ifTrue: [^self].

	launcher:= launcher, {loc}.
	ThisOSProcess
		forkJob: launcher first
		arguments: launcher allButFirst
		environment: nil
		descriptors: nil! !

!NewsqueakDockingBar methodsFor: 'as yet unclassified' stamp: 'ryan 6/13/2011 12:35'!
documentationLocation
	| dir rpm |
	dir:= ((FileDirectory on: SmalltalkImage current vmPath) directoryNamed: 'doc').
	dir exists ifTrue: [^dir fullNameFor: 'index.html'].
	rpm:= ExternalLauncher for: 'rpm'.
	rpm isProvided ifTrue: [
		rpm runWith: {'-qdf'. SmalltalkImage current getSystemAttribute: 0}
			ifSuccess: [ :stdout :stderr | | line |
				[nil = (line:= stdout nextLine)] whileFalse:
					[(line endsWith: 'index.html') ifTrue: [^line]]]
			ifFailure: [ :stdout :stderr | "Ignore failure code"]].
	^nil! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:38'!
getLauncher

	self unixLaunchers do:
		[ :ea | (FileDirectory default fileExists: ea) ifTrue: [^{ea}]].
	(FileDirectory default fileExists: self windowsLauncher) ifTrue: [
		^{'c:\windows\system32\cmd.exe'. '/c'. self windowsLauncher} ].
	^nil! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:38'!
getNameForNewImage
"Licensed under the Squeak License (the ''License''); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.squeak.org/SqueakLicense/"

| image newName aName anIndex |
image:= SmalltalkImage current.
aName:= FileDirectory baseNameFor: (FileDirectory default localNameFor: image imageName).
anIndex:= aName lastIndexOf: FileDirectory dot asCharacter ifAbsent: [nil].
(anIndex notNil and: [(aName copyFrom: anIndex + 1 to: aName size) isAllDigits])
	ifTrue:
		[aName:= aName copyFrom: 1 to: anIndex - 1].

^FileDirectory default nextNameFor: aName extension: FileDirectory imageSuffix! !

!NewsqueakDockingBar methodsFor: 'accessing' stamp: 'ryan 6/13/2011 12:33'!
imageName
	"Answer the value of imageName"

	^ imageName! !

!NewsqueakDockingBar methodsFor: 'accessing' stamp: 'ryan 6/13/2011 12:33'!
imageName: anObject
	"Set the value of imageName"

	imageName := anObject! !

!NewsqueakDockingBar methodsFor: 'initialize-release' stamp: 'ryan 8/2/2011 14:02'!
initialize

	super initialize.

	self addMenus.

	"self addMiddleLabel."

	self addSpacer.

	self addMorphBack: (ClockMorph new show24hr: false; showSeconds: false; yourself).

	self addSpace: 10.

	self adhereToTop.

	self autoGradient: true.! !

!NewsqueakDockingBar methodsFor: 'testing' stamp: 'eem 10/5/2007 13:29'!
isNewsqueakDockingBarMorph
	^true! !

!NewsqueakDockingBar methodsFor: 'as yet unclassified' stamp: 'Ahe 2/14/2008 14:40'!
isSticky
	^true! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:39'!
openChooserFor: list "<Collection>" nameBlock: block "<BlockContext>"
	| menu |

	self flag: #BOGUS. "Should use Brazil or Hopscotch instead"

	menu:= MenuMorph new.
	((SortedCollection sortBlock: [ :a :b | (block value: a) <= (block value: b) ]) addAll: list; yourself)
		do: [ :rep | menu add: rep description target: rep selector: #yourself ].
	menu add: '(Cancel)' target: nil selector: #yourself.
	^(menu invokeModal; selectedItem) ifNotNil: [ :item | item target ]! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 2/22/2012 12:07'!
openFile
	| fileRequester |
	fileRequester:= (Request usingPlatform: BlackMarket platform) File new
		initialDirectory: FileDirectory default fullName;
		title: 'Open file'.
	fileRequester openModal ifNotNil:
		[:fileName |
		FileList openEditorOn: (FileStream readOnlyFileNamed: fileName) editString: nil]! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'Ahe 4/28/2008 21:49'!
openFileList

	FileList prototypicalToolWindow openInWorld! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:39'!
openOsFileBrowser
	| launcher |

	OSProcess isWindows ifTrue: [
		NsToolSet
			windowsShellExecuteOperation: 'explore'
			file: FileDirectory default fullName
			parameters: 0
			directory: 0.
		^self].

	launcher:= self getLauncher.
	launcher = nil ifTrue: [ ^self ].
	launcher:= launcher, {FileDirectory default fullName}.
	ThisOSProcess
		forkJob: launcher first
		arguments: launcher allButFirst
		environment: nil
		descriptors: nil! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'Ahe 10/3/2008 17:45'!
quit
	NsToolSet quit! !

!NewsqueakDockingBar methodsFor: 'as yet unclassified' stamp: 'ryan 6/13/2011 12:35'!
refreshImageName
	imageName ~= nil ifTrue:
		[imageName contents:
			(self unsavedSourcesInImage ifTrue: ['*'] ifFalse:['']), self baseMiddleLabel]! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:39'!
reloadSelf

	self delete.
	self species new openInWorld! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 2/22/2012 12:07'!
runApp
	| fileRequester |
	fileRequester:= (Request usingPlatform: BlackMarket platform) File new.
	fileRequester allowedFileTypes: {
		'Newspeak object format files (*.nof)' ->'*.nof'.
		'gzipped Newspeak object format files  (*.nof.gz)' -> '*.nof.gz'.
		'Any files (*.*)' -> '*.*'}.
	fileRequester initialDirectory: (FileDirectory default fullName).
	fileRequester openModal ifNotNil: [:fn |
		(Deployment appFrom: fn) main: BlackMarket platform args: {}
	].! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 7/26/2011 13:36'!
saveImage

	NsToolSet exitFromFullScreenDuring: [
		WorldState addDeferredUIMessage: [
			SmalltalkImage current snapshot: true andQuit: false]]! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:40'!
saveImage: image inFileNamed: aString
"Licensed under the Squeak License (the ''License''); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.squeak.org/SqueakLicense/"

	| fullImageName |
	
	fullImageName:= FileDirectory default fullNameFor: aString.
	(FileDirectory default directoryNamed:(FileDirectory dirPathFor: fullImageName )) assureExistence.
	image
		changeImageNameTo: fullImageName;
		closeSourceFiles;
		openSourceFiles;  "so SNAPSHOT appears in new changes file"
		saveImageSegments.
	^image snapshot: true andQuit: false! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 6/13/2011 12:40'!
saveImageAs
	self saveImageAs: self getNameForNewImage dialogTitle: 'Save As'! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 2/22/2012 12:08'!
saveImageAs: suggestedImageName dialogTitle: dialogTitle
	| fileRequester |
	fileRequester:= (Request usingPlatform: BlackMarket platform) NewFile new
		initialDirectory: FileDirectory default fullName;
		initialFile: suggestedImageName;
		title: dialogTitle.
	fileRequester openModal ifNotNil: [ :fn | self saveImageNamed: fn]

"| window column text btn row |

window:: Window create.
column:: Column create.
text:: TextView create.
row:: Row create.

window title: dialogTitle.

column gap: 8.

row add: Blank create.
row gap: 8.
row children last area elasticity: 1.
row children last area width: 200.

btn:: PushButton create.
btn label: 'Ok'.
btn action: [window close. saveImageNamed: text text].
row add: btn.

btn:: PushButton create.
btn label: 'Cancel'.
btn action: [window close].
row add: btn.

window content: column.
column add: text.
column add: row.

text area elasticity: 1.
text text: suggestedImageName.

window areaClass: Anchor.
window area beCentered.
window open"! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 2/22/2012 12:08'!
saveImageNamed: newName

^self saveImageNamed: newName ifChangesPresent: [^BlackMarket platform brazil tools MessageBox new ok: 'A .changes file for', newName, ' already exists.  Aborting.'; open]! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'ryan 7/26/2011 13:38'!
saveImageNamed: newName ifChangesPresent: aBlock
"Licensed under the Squeak License (the ''License''); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.squeak.org/SqueakLicense/"
	| image changesName |

	image:= SmalltalkImage current.
	changesName:= image fullNameForChangesNamed: newName.

	"Check to see if there is a .changes file that would cause a problem if we saved a new .image file with the new version number"
	(FileDirectory default fileOrDirectoryExists: changesName) ifTrue: [^aBlock value].

	(SourceFiles at: 2)
		ifNotNil:
			[image closeSourceFiles; "so copying the changes file will always work"
			saveChangesInFileNamed: (image fullNameForChangesNamed: newName)].
	NsToolSet exitFromFullScreenDuring:[
		WorldState addDeferredUIMessage: [
			self saveImage: image inFileNamed: (image fullNameForImageNamed: newName)]]! !

!NewsqueakDockingBar methodsFor: 'attic' stamp: 'ryan 2/22/2012 12:07'!
scanAllMonticelloPackages
	| answer  repository |

	repository:= self openChooserFor: (MCRepositoryGroup default repositories select: [:rep| rep description startsWith: 'svn://']) nameBlock: [ :rep | rep description ].
	repository = nil ifTrue: [ ^self ].

	answer:= BlackMarket platform brazil tools MessageBox new yesNo: 'About to update all packages in ', repository description, '.  This may take a long time.  Are you sure you wish to continue?'; open.
	answer = #yes ifFalse: [ ^self ].

	repository:= MCRepositoryGroup default repositories
		detect: [ :each | each description = repository description ]
		ifNone: [ ^self ].
	repository packages
		do: [ :pkg | repository versionsAvailableForPackage: (MCPackage named: pkg name)]
		displayingProgress: 'Updating ', repository description! !

!NewsqueakDockingBar methodsFor: 'event handling' stamp: 'ryan 6/13/2011 12:37'!
shutDown

	self refreshImageName! !

!NewsqueakDockingBar methodsFor: 'event handling' stamp: 'ryan 6/13/2011 12:37'!
startUp

	self startStepping! !

!NewsqueakDockingBar methodsFor: 'as yet unclassified' stamp: 'ryan 6/13/2011 12:36'!
step

	self refreshImageName! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'Ahe 3/24/2008 17:01'!
unixLaunchers

	^{'/usr/bin/gnome-open'. '/usr/bin/htmlview'. '/usr/bin/open'}! !

!NewsqueakDockingBar methodsFor: 'as yet unclassified' stamp: 'Ahe 2/21/2008 16:31'!
unsavedSourcesInImage

	^UnversionedSourceManager new
		ifNil: [false]
		ifNotNil: [:sm | sm hasUnsavedChanges]! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'Ahe 9/3/2008 13:38'!
updateApplications: menu

	ToolSet updateApplicationsMenu: menu forMenuBar: self! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'Ahe 9/29/2007 19:42'!
updateChanges: menu

	menu
		defaultTarget: self;
		add: 'Open Simple Change Sorter' target: ToolSet default action: #openChangeSorter;
		add: 'Open Dual Change Sorter' target: ToolSet default action: #openDualChangeSorter;
		add: 'Browse change log (crash recovery)' action: #browseChangeLog;
		add: 'Check for slips (breakpoints, etc)' action: #checkForSlips! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'ryan 6/13/2011 12:41'!
updateFile: menu
	| preferences |

	preferences:= DynamicMenuMorph new
		updater: self updateSelector: #updatePreference:;
		updateMenu.
	menu
		defaultTarget: self;
		add: 'Open File' action: #openFile;
		add: 'Open File List' action: #openFileList;
		add: 'Open OS File Browser' action: #openOsFileBrowser;
		add: 'Documentation' action: #documentation;
		add: 'Compile File' action: #compileLanguageFile;
		addLine;
		add: 'Reload This Menu' action: #reloadSelf;
		addLine;
		add: 'Preferences' subMenu: preferences;
		addLine;
		add: 'Save Image' action: #saveImage;
		add: 'Save Image As...' action: #saveImageAs;
		add: 'Quit' action: #quit! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'Ahe 9/9/2008 15:44'!
updatePreference: menu

	menu
		add: 'Go native' target: NativeSession selector: #goNative;
		add: 'Go Morphic' target: NativeSession selector: #goMorphic;
		add: 'Open Preference Browser' target: PreferenceBrowser selector: #open;
		add: 'Regular Fonts' target: NsAppearance selector: #installLargeFontPreferences;
		add: 'Small Fonts' target: NsAppearance selector: #installFontPreferences! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'Ahe 9/29/2007 17:44'!
updateTools: menu

	menu
		defaultTarget: ToolSet default;
		addList: ToolSet menuItems! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'Ahe 9/29/2007 19:56'!
updateView: menu

	menu defaultTarget: self.

	menu
		add: 'Toggle Full Screen'
		target: TheWorldMainDockingBar instance
		selector: #toggleFullScreen.
	menu
		add: 'Refresh Display'
		target: World
		selector: #restoreMorphicDisplay.
	menu
		add: 'Transcript'
		target: NewsqueakDockingBar
		selector: #stickyTranscript.
	menu
		add: 'Big Transcript'
		target: NewsqueakDockingBar
		selector: #stickyBigTranscript! !

!NewsqueakDockingBar methodsFor: 'menu-bar' stamp: 'ryan 6/13/2011 12:41'!
updateWindows: menu
	| windows |
	
	windows:= SystemWindow windowsIn: self world satisfying: [ :each | true ].
	windows:= WeakArray withAll: windows.
	1 to: windows size do:
		[ :idx |
		menu
			add: ((windows at: idx) isCollapsed ifTrue: [ '[ ', (windows at: idx) label, ' ]' ] ifFalse: [ (windows at: idx) label ])
			target:
				[ :i | | w |
				w:= windows at: i.
				w ifNotNil: [ w activate; expand ] ]
			selector: #value:
			argumentList: {idx} ].

	windows isEmpty
		ifTrue: [ menu add: 'No windows' action: self class "no-op" ].! !

!NewsqueakDockingBar methodsFor: 'menu-action-file' stamp: 'Ahe 9/27/2007 12:58'!
windowsLauncher

	^'c:\windows\explorer.exe'! !
NewsqueakDockingBar initialize!
